<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Organization Public API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Twilio\Rest\PreviewIam\Versionless\Organization;

use Twilio\Exceptions\TwilioException;
use Twilio\ListResource;
use Twilio\Options;
use Twilio\Stream;
use Twilio\Values;
use Twilio\Version;


class RoleAssignmentList extends ListResource
    {
    /**
     * Construct the RoleAssignmentList
     *
     * @param Version $version Version that contains the resource
     * @param string $organizationSid
     */
    public function __construct(
        Version $version,
        string $organizationSid
    ) {
        parent::__construct($version);

        // Path Solution
        $this->solution = [
        'organizationSid' =>
            $organizationSid,
        
        ];

        $this->uri = '/' . \rawurlencode($organizationSid)
        .'/RoleAssignments';
    }

    /**
     * Create the RoleAssignmentInstance
     *
     * @param PublicApiCreateRoleAssignmentRequest $publicApiCreateRoleAssignmentRequest
     * @return RoleAssignmentInstance Created RoleAssignmentInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function create(PublicApiCreateRoleAssignmentRequest $publicApiCreateRoleAssignmentRequest): RoleAssignmentInstance
    {

        $headers = Values::of(['Content-Type' => 'application/json', 'Accept' => 'application/json' ]);
        $data = $publicApiCreateRoleAssignmentRequest->toArray();
        $payload = $this->version->create('POST', $this->uri, [], $data, $headers);

        return new RoleAssignmentInstance(
            $this->version,
            $payload,
            $this->solution['organizationSid']
        );
    }


    /**
     * Reads RoleAssignmentInstance records from the API as a list.
     * Unlike stream(), this operation is eager and will load `limit` records into
     * memory before returning.
     *
     * @param array|Options $options Optional Arguments
     * @param int $limit Upper limit for the number of records to return. read()
     *                   guarantees to never return more than limit.  Default is no
     *                   limit
     * @param mixed $pageSize Number of records to fetch per request, when not set
     *                        will use the default value of 50 records.  If no
     *                        page_size is defined but a limit is defined, read()
     *                        will attempt to read the limit with the most
     *                        efficient page size, i.e. min(limit, 1000)
     * @return RoleAssignmentInstance[] Array of results
     */
    public function read(array $options = [], int $limit = null, $pageSize = null): array
    {
        return \iterator_to_array($this->stream($options, $limit, $pageSize), false);
    }

    /**
     * Streams RoleAssignmentInstance records from the API as a generator stream.
     * This operation lazily loads records as efficiently as possible until the
     * limit
     * is reached.
     * The results are returned as a generator, so this operation is memory
     * efficient.
     *
     * @param array|Options $options Optional Arguments
     * @param int $limit Upper limit for the number of records to return. stream()
     *                   guarantees to never return more than limit.  Default is no
     *                   limit
     * @param mixed $pageSize Number of records to fetch per request, when not set
     *                        will use the default value of 50 records.  If no
     *                        page_size is defined but a limit is defined, stream()
     *                        will attempt to read the limit with the most
     *                        efficient page size, i.e. min(limit, 1000)
     * @return Stream stream of results
     */
    public function stream(array $options = [], int $limit = null, $pageSize = null): Stream
    {
        $limits = $this->version->readLimits($limit, $pageSize);

        $page = $this->page($options, $limits['pageSize']);

        return $this->version->stream($page, $limits['limit'], $limits['pageLimit']);
    }

    /**
     * Retrieve a single page of RoleAssignmentInstance records from the API.
     * Request is executed immediately
     *
     * @param mixed $pageSize Number of records to return, defaults to 50
     * @param string $pageToken PageToken provided by the API
     * @param mixed $pageNumber Page Number, this value is simply for client state
     * @return RoleAssignmentPage Page of RoleAssignmentInstance
     */
    public function page(
        array $options = [],
        $pageSize = Values::NONE,
        string $pageToken = Values::NONE,
        $pageNumber = Values::NONE
    ): RoleAssignmentPage
    {
        $options = new Values($options);

        $params = Values::of([
            'Identity' =>
                $options['identity'],
            'Scope' =>
                $options['scope'],
            'PageToken' => $pageToken,
            'Page' => $pageNumber,
            'PageSize' => $pageSize,
        ]);

        $headers = Values::of(['Content-Type' => 'application/x-www-form-urlencoded', 'Accept' => 'application/json']);
        $response = $this->version->page('GET', $this->uri, $params, [], $headers);

        return new RoleAssignmentPage($this->version, $response, $this->solution);
    }

    /**
     * Retrieve a specific page of RoleAssignmentInstance records from the API.
     * Request is executed immediately
     *
     * @param string $targetUrl API-generated URL for the requested results page
     * @return RoleAssignmentPage Page of RoleAssignmentInstance
     */
    public function getPage(string $targetUrl): RoleAssignmentPage
    {
        $response = $this->version->getDomain()->getClient()->request(
            'GET',
            $targetUrl
        );

        return new RoleAssignmentPage($this->version, $response, $this->solution);
    }


    /**
     * Constructs a RoleAssignmentContext
     *
     * @param string $sid
     */
    public function getContext(
        string $sid
        
    ): RoleAssignmentContext
    {
        return new RoleAssignmentContext(
            $this->version,
            $this->solution['organizationSid'],
            $sid
        );
    }

    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString(): string
    {
        return '[Twilio.PreviewIam.Versionless.RoleAssignmentList]';
    }
}
